# HG changeset patch
# Node ID 91204fad1b54
# Parent  ffc82edcdbfe
diff --git a/ChangeLog.API b/ChangeLog.API
--- a/ChangeLog.API
+++ b/ChangeLog.API
@@ -248,6 +248,7 @@
 		  instead.
 		* account-setting-info, account-set-info signals
 		* account-status-changing signal.
+		* buddy-status-changed signal.
 		* chat-topic-changed signal.
 		* file-recv-accept, file-recv-cancel, file-recv-complete,
 		  file-recv-start, file-send-accept, file-send-cancel,
@@ -273,6 +274,7 @@
 		* purple_account_add_buddies_with_invite
 		* purple_account_add_buddy_with_invite
 		* purple_account_destroy_log
+		* purple_account_get_active_status
 		* purple_account_get_check_mail
 		* purple_account_get_log
 		* purple_account_get_name_for_display. Use
@@ -284,11 +286,16 @@
 		* purple_account_get_private_alias. Use purple_contact_get_alias
 		  instead.
 		* purple_account_get_silence_suppression
+		* purple_account_get_status
+		* purple_account_get_status_type
+		* purple_account_get_status_type_with_primitive
+		* purple_account_get_status_types
 		* purple_account_get_ui_int
 		* purple_account_get_ui_string
 		* purple_account_get_ui_bool
 		* purple_account_get_username. Use purple_contact_info_get_username
 		  instead.
+		* purple_account_is_status_active
 		* purple_account_notify_added
 		* purple_account_privacy_allow
 		* purple_account_privacy_check
@@ -313,11 +320,15 @@
 		  instead.
 		* purple_account_set_public_alias
 		* purple_account_set_silence_suppression
+		* purple_account_set_status
+		* purple_account_set_status_attrs
+		* purple_account_set_status_types
 		* purple_account_set_ui_int
 		* purple_account_set_ui_string
 		* purple_account_set_ui_bool
 		* purple_account_set_username. Use purple_contact_info_set_username
 		  instead.
+		* account-status-changed signal
 		* purple_accounts_add
 		* purple_accounts_find
 		* purple_accounts_get_all
@@ -605,6 +616,12 @@
 		* PurplePounceEvent
 		* PurplePounceOption
 		* PurplePrefsUiOps
+		* purple_presence_get_status
+		* purple_presence_get_statuses
+		* purple_presence_is_status_active
+		* purple_presence_is_status_primitive_active
+		* purple_presence_set_status_active
+		* purple_presence_switch_status
 		* purple_protocol_got_account_actions
 		* purple_protocol_got_account_idle
 		* purple_protocol_got_account_status
diff --git a/doc/reference/libpurple/libpurple.toml.in b/doc/reference/libpurple/libpurple.toml.in
--- a/doc/reference/libpurple/libpurple.toml.in
+++ b/doc/reference/libpurple/libpurple.toml.in
@@ -47,7 +47,6 @@
 	"signals_conversation.md",
 	"signals_core.md",
 	"signals_jabber.md",
-	"signals_savedstatus.md",
 	"tut_c_plugins.md",
 ]
 content_images = [
diff --git a/doc/reference/libpurple/meson.build b/doc/reference/libpurple/meson.build
--- a/doc/reference/libpurple/meson.build
+++ b/doc/reference/libpurple/meson.build
@@ -8,8 +8,6 @@
 	'signals_connection.md',
 	'signals_conversation.md',
 	'signals_core.md',
-	'signals_jabber.md',
-	'signals_savedstatus.md',
 	'tut_c_plugins.md',
 ]
 
diff --git a/libpurple/accounts.c b/libpurple/accounts.c
--- a/libpurple/accounts.c
+++ b/libpurple/accounts.c
@@ -625,11 +625,6 @@
 	void *handle = purple_accounts_get_handle();
 	void *conn_handle = purple_connections_get_handle();
 
-	purple_signal_register(handle, "account-status-changed",
-						 purple_marshal_VOID__POINTER_POINTER_POINTER,
-						 G_TYPE_NONE, 3, PURPLE_TYPE_ACCOUNT,
-						 PURPLE_TYPE_STATUS, PURPLE_TYPE_STATUS);
-
 	purple_signal_register(handle, "account-signed-on",
 	                       purple_marshal_VOID__POINTER, G_TYPE_NONE, 1,
 	                       PURPLE_TYPE_ACCOUNT);
diff --git a/libpurple/buddy.h b/libpurple/buddy.h
--- a/libpurple/buddy.h
+++ b/libpurple/buddy.h
@@ -46,7 +46,6 @@
 #include "purpleaccount.h"
 #include "purplepresence.h"
 #include "purpleversion.h"
-#include "status.h"
 
 /**
  * PURPLE_BUDDY_IS_ONLINE:
@@ -271,20 +270,6 @@
 PurplePresence *purple_buddy_get_presence(PurpleBuddy *buddy);
 
 /**
- * purple_buddy_update_status:
- * @buddy:      The buddy whose status has changed.
- * @old_status: The status from which we are changing.
- *
- * Updates a buddy's status.
- *
- * This should only be called from within Purple.
- *
- * Since: 3.0
- */
-PURPLE_AVAILABLE_IN_3_0
-void purple_buddy_update_status(PurpleBuddy *buddy, PurpleStatus *old_status);
-
-/**
  * purple_buddy_get_media_caps:
  * @buddy: The buddy.
  *
diff --git a/libpurple/buddy.c b/libpurple/buddy.c
--- a/libpurple/buddy.c
+++ b/libpurple/buddy.c
@@ -191,7 +191,8 @@
 	}
 
 	priv->presence = purple_presence_new();
-	purple_presence_set_status_active(priv->presence, "offline", TRUE);
+	purple_presence_set_primitive(priv->presence,
+	                              PURPLE_PRESENCE_PRIMITIVE_OFFLINE);
 
 	purple_blist_new_node(purple_blist_get_default(),
 	                      PURPLE_BLIST_NODE(buddy));
@@ -704,78 +705,6 @@
 	return priv->presence;
 }
 
-void
-purple_buddy_update_status(PurpleBuddy *buddy, PurpleStatus *old_status) {
-	PurpleBuddyList *blist = NULL;
-	PurpleBuddyPrivate *priv = NULL;
-	PurpleStatus *status = NULL;
-	gpointer handle = NULL;
-
-	gboolean old_online = FALSE, new_online = FALSE;
-
-	g_return_if_fail(PURPLE_IS_BUDDY(buddy));
-
-	priv = purple_buddy_get_instance_private(buddy);
-	status = purple_presence_get_active_status(priv->presence);
-	blist = purple_blist_get_default();
-	handle = purple_blist_get_handle();
-
-	purple_debug_info("blistnodetypes", "Updating buddy status for %s (%s)\n",
-	                  priv->name,
-	                  purple_account_get_protocol_name(priv->account));
-
-	old_online = purple_status_is_online(old_status);
-	new_online = purple_status_is_online(status);
-
-	if(old_online != new_online) {
-		PurpleBlistNode *cnode = NULL, *gnode = NULL;
-		PurpleMetaContact *contact = NULL;
-		PurpleCountingNode *contact_counter = NULL, *group_counter = NULL;
-		gint delta = 0, limit = 0;
-
-		if(new_online) {
-			purple_signal_emit(handle, "buddy-signed-on", buddy);
-			delta = 1;
-			limit = 1;
-		} else {
-			purple_blist_node_set_int(PURPLE_BLIST_NODE(buddy), "last_seen",
-			                          time(NULL));
-
-			purple_signal_emit(handle, "buddy-signed-off", buddy);
-			delta = -1;
-			limit = 0;
-		}
-
-		cnode = purple_blist_node_get_parent(PURPLE_BLIST_NODE(buddy));
-		contact = PURPLE_META_CONTACT(cnode);
-		contact_counter = PURPLE_COUNTING_NODE(contact);
-		gnode = purple_blist_node_get_parent(cnode);
-		group_counter = PURPLE_COUNTING_NODE(gnode);
-
-		purple_counting_node_change_online_count(contact_counter, delta);
-		if(purple_counting_node_get_online_count(contact_counter) == limit) {
-			purple_counting_node_change_online_count(group_counter, delta);
-		}
-	} else {
-		purple_signal_emit(handle, "buddy-status-changed", buddy, old_status,
-		                   status);
-	}
-
-	/*
-	 * This function used to only call the following two functions if one of
-	 * the above signals had been triggered, but that's not good, because
-	 * if someone's away message changes and they don't go from away to back
-	 * to away then no signal is triggered.
-	 *
-	 * It's a safe assumption that SOMETHING called this function.  PROBABLY
-	 * because something, somewhere changed.  Calling the stuff below
-	 * certainly won't hurt anything.  Unless you're on a K6-2 300.
-	 */
-	purple_meta_contact_invalidate_priority_buddy(purple_buddy_get_contact(buddy));
-
-	purple_blist_update_node(blist, PURPLE_BLIST_NODE(buddy));
-}
-
 PurpleMediaCaps
 purple_buddy_get_media_caps(PurpleBuddy *buddy) {
 	PurpleBuddyPrivate *priv = NULL;
diff --git a/libpurple/buddylist.c b/libpurple/buddylist.c
--- a/libpurple/buddylist.c
+++ b/libpurple/buddylist.c
@@ -1912,7 +1912,8 @@
 
 	for (iter = list; iter; iter = iter->next)
 	{
-		purple_presence_set_status_active(iter->data, "offline", TRUE);
+		purple_presence_set_primitive(iter->data,
+		                              PURPLE_PRESENCE_PRIMITIVE_OFFLINE);
 	}
 	g_list_free(list);
 }
@@ -2084,10 +2085,6 @@
 	/* Set a default, which can't be done as a static initializer. */
 	buddy_list_type = PURPLE_TYPE_BUDDY_LIST;
 
-	purple_signal_register(handle, "buddy-status-changed",
-	                     purple_marshal_VOID__POINTER_POINTER_POINTER,
-	                     G_TYPE_NONE, 3, PURPLE_TYPE_BUDDY, PURPLE_TYPE_STATUS, 
-	                     PURPLE_TYPE_STATUS);
 	purple_signal_register(handle, "buddy-privacy-changed",
 	                     purple_marshal_VOID__POINTER, G_TYPE_NONE,
 	                     1, PURPLE_TYPE_BUDDY);
diff --git a/libpurple/connection.h b/libpurple/connection.h
--- a/libpurple/connection.h
+++ b/libpurple/connection.h
@@ -112,7 +112,6 @@
 #include "purpleaccount.h"
 #include "purpleconnectionerrorinfo.h"
 #include "purpleprotocol.h"
-#include "status.h"
 
 struct _PurpleConnectionClass {
 	/*< private >*/
diff --git a/libpurple/core.c b/libpurple/core.c
--- a/libpurple/core.c
+++ b/libpurple/core.c
@@ -44,9 +44,7 @@
 #include "purplepath.h"
 #include "purplepresencemanagerprivate.h"
 #include "purpleprivate.h"
-#include "savedstatuses.h"
 #include "signals.h"
-#include "status.h"
 #include "util.h"
 #ifdef _WIN32
 #include "win32/win32dep.h"
@@ -149,17 +147,15 @@
 	 */
 	purple_plugins_init();
 
-	/* Accounts use status, buddy icons and connection signals, so
-	 * initialize these before accounts
+	/* Accounts buddy icons and connection signals, so initialize these before
+	 * accounts.
 	 */
-	purple_statuses_init();
 	purple_buddy_icons_init();
 	purple_connections_init();
 
 	purple_account_manager_startup();
 	purple_accounts_init();
 	purple_contact_manager_startup();
-	purple_savedstatuses_init();
 	purple_presence_manager_startup();
 	purple_notify_init();
 	purple_conversations_init();
@@ -241,8 +237,6 @@
 	purple_connections_uninit();
 	purple_buddy_icons_uninit();
 	purple_presence_manager_shutdown();
-	purple_savedstatuses_uninit();
-	purple_statuses_uninit();
 	purple_accounts_uninit();
 	purple_proxy_uninit();
 	purple_network_uninit();
diff --git a/libpurple/meson.build b/libpurple/meson.build
--- a/libpurple/meson.build
+++ b/libpurple/meson.build
@@ -112,10 +112,8 @@
 	'request/purplerequestpage.c',
 	'request-datasheet.c',
 	'roomlist.c',
-	'savedstatuses.c',
 	'server.c',
 	'signals.c',
-	'status.c',
 	'util.c',
 	'xmlnode.c'
 ]
@@ -221,10 +219,8 @@
 	'request.h',
 	'request-datasheet.h',
 	'roomlist.h',
-	'savedstatuses.h',
 	'server.h',
 	'signals.h',
-	'status.h',
 	'util.h',
 	'xmlnode.h',
 ]
@@ -312,7 +308,6 @@
 	'purpleproxyinfo.h',
 	'purpletyping.h',
 	'roomlist.h',
-	'status.h',
 	'xmlnode.h'
 ]
 
diff --git a/libpurple/purpleaccount.h b/libpurple/purpleaccount.h
--- a/libpurple/purpleaccount.h
+++ b/libpurple/purpleaccount.h
@@ -41,7 +41,6 @@
 #include "purpleprotocol.h"
 #include "purpleproxyinfo.h"
 #include "purpleversion.h"
-#include "status.h"
 
 G_BEGIN_DECLS
 
@@ -253,71 +252,6 @@
 void purple_account_set_proxy_info(PurpleAccount *account, PurpleProxyInfo *info);
 
 /**
- * purple_account_set_status_types:
- * @account: The account.
- * @status_types: (element-type PurpleStatusType): The list of status types.
- *
- * Sets the account's status types.
- *
- * Since: 2.0
- */
-PURPLE_AVAILABLE_IN_ALL
-void purple_account_set_status_types(PurpleAccount *account, GList *status_types);
-
-/**
- * purple_account_set_status:
- * @account: The account.
- * @status_id: The ID of the status.
- * @active: Whether @status_id is to be activated (%TRUE) or deactivated
- *          (%FALSE).
- * @...: A %NULL-terminated list of pairs of `const char *` attribute name
- *       followed by `const char *` attribute value for the status. (For
- *       example, one pair might be `"message"` followed by `"hello, talk to
- *       me!"`.)
- *
- * Activates or deactivates a status.
- *
- * All changes to the statuses of an account go through this function or
- * [method@Purple.Account.set_status_attrs].
- *
- * You can only deactivate an exclusive status by activating another exclusive
- * status. So, if @status_id is an exclusive status and @active is %FALSE, this
- * function does nothing.
- *
- * Variadic version of [method@Purple.Account.set_status_attrs].
- *
- * Since: 2.0
- */
-PURPLE_AVAILABLE_IN_ALL
-void purple_account_set_status(PurpleAccount *account, const char *status_id, gboolean active, ...) G_GNUC_NULL_TERMINATED;
-
-
-/**
- * purple_account_set_status_attrs: (rename-to purple_account_set_status):
- * @account: The account.
- * @status_id: The ID of the status.
- * @active: Whether @status_id is to be activated (%TRUE) or deactivated
- *          (%FALSE).
- * @attrs: (element-type utf8 utf8): A hash table with keys of attribute
- *         names and values of attributes for the status. (For example, one
- *         pair might be a key of `"message"` with a value of `"hello, talk to
- *         me!"`.)
- *
- * Activates or deactivates a status.
- *
- * All changes to the statuses of an account go through this function or
- * [method@Purple.Account.set_status].
- *
- * You can only deactivate an exclusive status by activating another exclusive
- * status. So, if @status_id is an exclusive status and @active is %FALSE, this
- * function does nothing.
- *
- * Since: 3.0
- */
-PURPLE_AVAILABLE_IN_3_0
-void purple_account_set_status_attrs(PurpleAccount *account, const char *status_id, gboolean active, GHashTable *attrs);
-
-/**
  * purple_account_set_int:
  * @account: The account.
  * @name: The name of the setting.
@@ -514,67 +448,6 @@
 PurpleProxyInfo *purple_account_get_proxy_info(PurpleAccount *account);
 
 /**
- * purple_account_get_active_status:
- * @account: The account.
- *
- * Returns the active status for this account.  This looks through
- * the PurplePresence associated with this account and returns the
- * PurpleStatus that has its active flag set to "TRUE."  There can be
- * only one active PurpleStatus in a PurplePresence.
- *
- * Returns: (transfer none): The active status.
- *
- * Since: 2.0
- */
-PURPLE_AVAILABLE_IN_ALL
-PurpleStatus *purple_account_get_active_status(PurpleAccount *account);
-
-/**
- * purple_account_get_status:
- * @account: The account.
- * @status_id: The status ID.
- *
- * Returns the account status with the specified ID.
- *
- * Returns: (transfer none): The status, or %NULL if it was never registered.
- *
- * Since: 2.0
- */
-PURPLE_AVAILABLE_IN_ALL
-PurpleStatus *purple_account_get_status(PurpleAccount *account, const char *status_id);
-
-/**
- * purple_account_get_status_type:
- * @account: The account.
- * @id: The ID of the status type to find.
- *
- * Returns the account status type with the specified ID.
- *
- * Returns: The status type if found, or %NULL.
- *
- * Since: 2.0
- */
-PURPLE_AVAILABLE_IN_ALL
-PurpleStatusType *purple_account_get_status_type(PurpleAccount *account, const char *id);
-
-/**
- * purple_account_get_status_type_with_primitive:
- * @account: The account.
- * @primitive: The type of the status type to find.
- *
- * Returns the account status type with the specified primitive.
- * Note: It is possible for an account to have more than one
- * PurpleStatusType with the same primitive.  In this case, the
- * first PurpleStatusType is returned.
- *
- * Returns: The status if found, or %NULL.
- *
- * Since: 2.0
- */
-PURPLE_AVAILABLE_IN_ALL
-PurpleStatusType *purple_account_get_status_type_with_primitive(PurpleAccount *account, PurpleStatusPrimitive primitive);
-
-/**
  * purple_account_get_presence:
  * @account: The account.
  *
@@ -588,33 +461,6 @@
 PurplePresence *purple_account_get_presence(PurpleAccount *account);
 
 /**
- * purple_account_is_status_active:
- * @account: The account.
- * @status_id: The status ID.
- *
- * Returns whether or not an account status is active.
- *
- * Returns: TRUE if active, or FALSE if not.
- *
- * Since: 2.0
- */
-PURPLE_AVAILABLE_IN_ALL
-gboolean purple_account_is_status_active(PurpleAccount *account, const char *status_id);
-
-/**
- * purple_account_get_status_types:
- * @account: The account.
- *
- * Returns the account's status types.
- *
- * Returns: (transfer none) (element-type PurpleStatusType): The account's status types.
- *
- * Since: 2.0
- */
-PURPLE_AVAILABLE_IN_ALL
-GList *purple_account_get_status_types(PurpleAccount *account);
-
-/**
  * purple_account_get_int:
  * @account: The account.
  * @name: The name of the setting.
diff --git a/libpurple/purpleaccount.c b/libpurple/purpleaccount.c
--- a/libpurple/purpleaccount.c
+++ b/libpurple/purpleaccount.c
@@ -74,8 +74,6 @@
 
 	PurpleProxyInfo *proxy_info;
 
-	GList *status_types;
-
 	PurplePresence *presence;
 
 	PurpleConnectionErrorInfo *error;
@@ -807,8 +805,6 @@
 
 	purple_account_free_notify_settings(account);
 
-	purple_account_set_status_types(account, NULL);
-
 	g_clear_object(&account->proxy_info);
 
 	g_clear_pointer(&account->error, purple_connection_error_info_free);
@@ -1419,65 +1415,6 @@
 }
 
 void
-purple_account_set_status_types(PurpleAccount *account, GList *status_types) {
-	g_return_if_fail(PURPLE_IS_ACCOUNT(account));
-
-	/* Out with the old... */
-	g_list_free_full(account->status_types,
-	                 (GDestroyNotify)purple_status_type_destroy);
-
-	/* In with the new... */
-	account->status_types = status_types;
-}
-
-void
-purple_account_set_status(PurpleAccount *account, const char *status_id,
-                          gboolean active, ...)
-{
-	GHashTable *attrs;
-	va_list args;
-
-	va_start(args, active);
-	attrs = purple_attrs_from_vargs(args);
-	purple_account_set_status_attrs(account, status_id, active, attrs);
-	g_hash_table_destroy(attrs);
-	va_end(args);
-}
-
-void
-purple_account_set_status_attrs(PurpleAccount *account, const char *status_id,
-                                gboolean active, GHashTable *attrs)
-{
-	PurpleStatus *status;
-
-	g_return_if_fail(PURPLE_IS_ACCOUNT(account));
-	g_return_if_fail(status_id != NULL);
-
-	status = purple_account_get_status(account, status_id);
-	if(status == NULL) {
-		PurpleContactInfo *info = PURPLE_CONTACT_INFO(account);
-
-		purple_debug_error("account",
-		                   "Invalid status ID '%s' for account %s (%s)\n",
-		                   status_id,
-		                   purple_contact_info_get_username(info),
-		                   purple_account_get_protocol_id(account));
-
-		return;
-	}
-
-	if(active || purple_status_is_independent(status)) {
-		purple_status_set_active_with_attributes(status, active, attrs);
-	}
-
-	/*
-	 * Our current statuses are saved to accounts.xml (so that when we
-	 * reconnect, we go back to the previous status).
-	 */
-	purple_accounts_schedule_save();
-}
-
-void
 purple_account_set_int(PurpleAccount *account, const char *name, int value) {
 	PurpleAccountSetting *setting;
 
@@ -1631,59 +1568,6 @@
 	return account->proxy_info;
 }
 
-PurpleStatus *
-purple_account_get_active_status(PurpleAccount *account) {
-	g_return_val_if_fail(PURPLE_IS_ACCOUNT(account), NULL);
-
-	return purple_presence_get_active_status(account->presence);
-}
-
-PurpleStatus *
-purple_account_get_status(PurpleAccount *account, const char *status_id) {
-	g_return_val_if_fail(PURPLE_IS_ACCOUNT(account), NULL);
-	g_return_val_if_fail(status_id != NULL, NULL);
-
-	return purple_presence_get_status(account->presence, status_id);
-}
-
-PurpleStatusType *
-purple_account_get_status_type(PurpleAccount *account, const char *id) {
-	GList *l;
-
-	g_return_val_if_fail(PURPLE_IS_ACCOUNT(account), NULL);
-	g_return_val_if_fail(id != NULL, NULL);
-
-	for (l = purple_account_get_status_types(account); l != NULL; l = l->next)
-	{
-		PurpleStatusType *status_type = (PurpleStatusType *)l->data;
-
-		if(purple_strequal(purple_status_type_get_id(status_type), id)) {
-			return status_type;
-		}
-	}
-
-	return NULL;
-}
-
-PurpleStatusType *
-purple_account_get_status_type_with_primitive(PurpleAccount *account,
-                                              PurpleStatusPrimitive primitive)
-{
-	GList *l;
-
-	g_return_val_if_fail(PURPLE_IS_ACCOUNT(account), NULL);
-
-	for(l = purple_account_get_status_types(account); l != NULL; l = l->next) {
-		PurpleStatusType *status_type = (PurpleStatusType *)l->data;
-
-		if(purple_status_type_get_primitive(status_type) == primitive) {
-			return status_type;
-		}
-	}
-
-	return NULL;
-}
-
 PurplePresence *
 purple_account_get_presence(PurpleAccount *account) {
 	g_return_val_if_fail(PURPLE_IS_ACCOUNT(account), NULL);
@@ -1691,23 +1575,6 @@
 	return account->presence;
 }
 
-gboolean
-purple_account_is_status_active(PurpleAccount *account,
-                                const char *status_id)
-{
-	g_return_val_if_fail(PURPLE_IS_ACCOUNT(account), FALSE);
-	g_return_val_if_fail(status_id != NULL, FALSE);
-
-	return purple_presence_is_status_active(account->presence, status_id);
-}
-
-GList *
-purple_account_get_status_types(PurpleAccount *account) {
-	g_return_val_if_fail(PURPLE_IS_ACCOUNT(account), NULL);
-
-	return account->status_types;
-}
-
 int
 purple_account_get_int(PurpleAccount *account, const char *name,
                        int default_value)
diff --git a/libpurple/purplepresence.h b/libpurple/purplepresence.h
--- a/libpurple/purplepresence.h
+++ b/libpurple/purplepresence.h
@@ -52,8 +52,6 @@
 
 typedef struct _PurplePresence PurplePresence;
 
-#include "status.h"
-
 /**
  * PurplePresencePrimitive:
  * @PURPLE_PRESENCE_PRIMITIVE_OFFLINE: The presence is offline or otherwise
@@ -131,38 +129,6 @@
 PurplePresence *purple_presence_new(void);
 
 /**
- * purple_presence_set_status_active:
- * @presence: The #PurplePresence instance.
- * @status_id: The ID of the status.
- * @active: The active state.
- *
- * Sets the active state of a status in a presence.
- *
- * Only independent statuses can be set inactive. Normal statuses can only
- * be set active, so if you wish to disable a status, set another
- * non-independent status to active, or use purple_presence_switch_status().
- *
- * Since: 2.0
- */
-PURPLE_AVAILABLE_IN_ALL
-void purple_presence_set_status_active(PurplePresence *presence, const gchar *status_id, gboolean active);
-
-/**
- * purple_presence_switch_status:
- * @presence: The #PurplePresence instance.
- * @status_id: The status ID to switch to.
- *
- * Switches the active status in a presence.
- *
- * This is similar to purple_presence_set_status_active(), except it won't
- * activate independent statuses.
- *
- * Since: 2.0
- */
-PURPLE_AVAILABLE_IN_ALL
-void purple_presence_switch_status(PurplePresence *presence, const gchar *status_id);
-
-/**
  * purple_presence_set_idle:
  * @presence: The #PurplePresence instance.
  * @idle: The idle state.
@@ -190,46 +156,6 @@
 void purple_presence_set_login_time(PurplePresence *presence, GDateTime *login_time);
 
 /**
- * purple_presence_get_statuses:
- * @presence: The #PurplePresence instance.
- *
- * Gets a list of all the statuses in @presence.
- *
- * Returns: (element-type PurpleStatus) (transfer none): The statuses.
- *
- * Since: 2.0
- */
-PURPLE_AVAILABLE_IN_ALL
-GList *purple_presence_get_statuses(PurplePresence *presence);
-
-/**
- * purple_presence_get_status:
- * @presence: The #PurplePresence instance.
- * @status_id: The ID of the status.
- *
- * Gets the status with the specified ID from @presence.
- *
- * Returns: (transfer none): The #PurpleStatus if found, or %NULL.
- *
- * Since: 2.0
- */
-PURPLE_AVAILABLE_IN_ALL
-PurpleStatus *purple_presence_get_status(PurplePresence *presence, const gchar *status_id);
-
-/**
- * purple_presence_get_active_status:
- * @presence: The #PurplePresence instance.
- *
- * Gets the active exclusive status from @presence.
- *
- * Returns: (transfer none): The active exclusive status.
- *
- * Since: 2.0
- */
-PURPLE_AVAILABLE_IN_ALL
-PurpleStatus *purple_presence_get_active_status(PurplePresence *presence);
-
-/**
  * purple_presence_is_available:
  * @presence: The #PurplePresence instance.
  *
@@ -258,39 +184,6 @@
 gboolean purple_presence_is_online(PurplePresence *presence);
 
 /**
- * purple_presence_is_status_active:
- * @presence: The #PurplePresence instance.
- * @status_id: The ID of the status.
- *
- * Gets whether or not a status in @presence is active.
- *
- * A status is active if itself or any of its sub-statuses are active.
- *
- * Returns: %TRUE if the status is active, or %FALSE.
- *
- * Since: 2.0
- */
-PURPLE_AVAILABLE_IN_ALL
-gboolean purple_presence_is_status_active(PurplePresence *presence, const gchar *status_id);
-
-/**
- * purple_presence_is_status_primitive_active:
- * @presence: The #PurplePresence instance.
- * @primitive: The status primitive.
- *
- * Gets whether or not a status with the specified primitive type in @presence
- * is active.
- *
- * A status is active if itself or any of its sub-statuses are active.
- *
- * Returns: %TRUE if the status is active, or %FALSE.
- *
- * Since: 2.0
- */
-PURPLE_AVAILABLE_IN_ALL
-gboolean purple_presence_is_status_primitive_active(PurplePresence *presence, PurpleStatusPrimitive primitive);
-
-/**
  * purple_presence_is_idle:
  * @presence: The #PurplePresence instance.
  *
@@ -366,7 +259,7 @@
  * @presence: The instance.
  * @primitive: The new primitive.
  *
- * Sets the [enum@Purple.StatusPrimitive] for @presence to @primitive.
+ * Sets the [enum@Purple.PresencePrimitive] for @presence to @primitive.
  *
  * Since: 3.0
  */
